#ifndef __CODA_PRIOR_MULT_
#define __CODA_PRIOR_MULT__

#include "CodaBasePriorita.h"
#include "CodaVect.h"

template <class Elem> 
class CodaPrioritaMultipla : public CodaBasePriorita<Elem> {
 private:
        CodaVect<Elem>  *dati;
        int   MaxPriorita;
 public:

        CodaPrioritaMultipla(int mp);
        virtual ~CodaPrioritaMultipla();
        virtual bool enqueue(Elem e, int priorita);
        virtual bool dequeue();
        virtual bool head(Elem &e);
        bool isempty();
};

template <class Elem> 
CodaPrioritaMultipla<Elem>::CodaPrioritaMultipla(int mp)
{
   MaxPriorita = mp;
   dati = new CodaVect<Elem>[MaxPriorita];      
}

template <class Elem> 
CodaPrioritaMultipla<Elem>::~CodaPrioritaMultipla()
{
   delete[] dati;       
}

template <class Elem> 
bool CodaPrioritaMultipla<Elem>::enqueue(Elem e, int priorita)
{
     if (priorita < 0 || priorita >= MaxPriorita)
     {
        return false;                     
     }    
     dati[priorita].enqueue(e);
     return true;
};

template <class Elem> 
bool CodaPrioritaMultipla<Elem>::dequeue() {
     
     for (int i=0; i<MaxPriorita; i++)
         if (!dati[i].isempty())
         {
            dati[i].dequeue();
            return true;
         }
     return false;    
};

template <class Elem> 
bool CodaPrioritaMultipla<Elem>::head(Elem &e)
{
     for (int i=0; i<MaxPriorita; i++)
         if (!dati[i].isempty())
         {
            dati[i].head(e);
            return true;
         }
     return false;    
};

template <class Elem> 
bool CodaPrioritaMultipla<Elem>::isempty() 
{
     for (int i=0; i<MaxPriorita; i++)
         if (!dati[i].isempty())
            return false;
     return true;     
}

#endif
